Index: src/sas/qtgui/Perspectives/Fitting/FittingWidget.py
===================================================================
--- src/sas/qtgui/Perspectives/Fitting/FittingWidget.py	(revision 83eb5208b8acb86b064162274de583670f72da47)
+++ src/sas/qtgui/Perspectives/Fitting/FittingWidget.py	(revision 9d266d2a26a5ec599562e4892355fd031c3ef5ff)
@@ -25,4 +25,5 @@
 from sas.sasgui.perspectives.fitting.model_thread import Calc1D
 from sas.sasgui.perspectives.fitting.model_thread import Calc2D
+from sas.sasgui.perspectives.fitting.utils import get_weight
 
 from UI.FittingWidgetUI import Ui_FittingWidgetUI
@@ -67,4 +68,6 @@
         # Parameters to fit
         self.parameters_to_fit = None
+        # Weight radio box group
+        self.weightingGroup = QtGui.QButtonGroup()
 
         # Which tab is this widget displayed in?
@@ -231,7 +234,12 @@
         self.tabFitting.setTabEnabled(TAB_MAGNETISM, False)
         self.lblChi2Value.setText("---")
-        # group boxes
+        # Group boxes
         self.boxWeighting.setEnabled(False)
         self.cmdMaskEdit.setEnabled(False)
+        # Button groups
+        self.weightingGroup.addButton(self.rbWeighting1)
+        self.weightingGroup.addButton(self.rbWeighting2)
+        self.weightingGroup.addButton(self.rbWeighting3)
+        self.weightingGroup.addButton(self.rbWeighting4)
 
     def initializeSignals(self):
@@ -260,4 +268,6 @@
         self.txtSmearUp.editingFinished.connect(self.onSmearUp)
         self.txtSmearDown.editingFinished.connect(self.onSmearDown)
+        # Button groups
+        self.weightingGroup.buttonClicked.connect(self.onWeightingChoice)
 
         # Respond to change in parameters from the UI
@@ -353,4 +363,13 @@
         """
         pass
+
+    def onWeightingChoice(self, button):
+        """
+        Update weighting in the fit state
+        """
+        button_id = button.group().checkedId()
+        button_id = abs(button_id + 2)
+        #self.fitPage.weighting = button_id
+        print button_id
 
     def onPolyModelChange(self, item):
@@ -401,4 +420,7 @@
         params_to_fit = self.parameters_to_fit
 
+        # Potential weights added
+        self.addWeightingToData(data)
+
         # These should be updating somehow?
         fit_id = 0
@@ -688,4 +710,20 @@
         checked_list = ['scale', '1.0', '0.0', 'inf', '']
         FittingUtilities.addCheckedListToModel(model, checked_list)
+
+    def addWeightingToData(self, data):
+        """
+        Adds weighting contribution to fitting data
+        """
+        # Check the state of the Weighting radio buttons
+        button_id = self.weightingGroup.checkedId()
+        button_id = abs(button_id + 2)
+        if button_id == 0:
+            return
+        # Send original data for weighting
+        weight = get_weight(data=data, is2d=self.is2D, flag=button_id)
+        if self.is2D:
+            data.err_data = weight
+        else:
+            data.dy = weight
 
     def updateQRange(self):
Index: src/sas/qtgui/Perspectives/Fitting/UI/FittingWidgetUI.ui
===================================================================
--- src/sas/qtgui/Perspectives/Fitting/UI/FittingWidgetUI.ui	(revision 6c8fb2ce67ed94f8fd44ef74eff5f71b3cd6b6f6)
+++ src/sas/qtgui/Perspectives/Fitting/UI/FittingWidgetUI.ui	(revision 9d266d2a26a5ec599562e4892355fd031c3ef5ff)
@@ -511,5 +511,5 @@
            <layout class="QVBoxLayout" name="verticalLayout">
             <item>
-             <widget class="QRadioButton" name="radioButton">
+             <widget class="QRadioButton" name="rbWeighting1">
               <property name="text">
                <string>None</string>
@@ -521,5 +521,5 @@
             </item>
             <item>
-             <widget class="QRadioButton" name="radioButton_2">
+             <widget class="QRadioButton" name="rbWeighting2">
               <property name="text">
                <string>Use dI Data</string>
@@ -528,5 +528,5 @@
             </item>
             <item>
-             <widget class="QRadioButton" name="radioButton_3">
+             <widget class="QRadioButton" name="rbWeighting3">
               <property name="text">
                <string>Use |sqrt(I Data)|</string>
@@ -535,5 +535,5 @@
             </item>
             <item>
-             <widget class="QRadioButton" name="radioButton_4">
+             <widget class="QRadioButton" name="rbWeighting4">
               <property name="text">
                <string>Use |I Data|</string>
